﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr157_1
{
    // Интерфейс: 
    interface MyInterface {
        // Объявление методов: 
        void show(); 
        void setNum(int n); 
        int getNum();
        // Объявление свойства: 
        int number { 
            get; 
            set;
        }
        // Объявление индексатора: 
        int this[int k] { 
            get;
        }
    }

    // Класс реализует интерфейс: 
    class MyClass: MyInterface {
        // Закрытое целочисленное поле: 
        private int num;
        // Конструктор с одним аргументом:
        public MyClass(int n) {
            // Присваивание значения свойству: 
            number = n;
            // Вызывается метод из интерфейса: 
            show();
        }
        // Описание метода из интерфейса: 
        public void show() {
            // Отображение значения свойства: 
            Console.WriteLine("Свойство number = " + number);
        }
        // Описание метода из интерфейса: 
        public void setNum(int n) {
            // Присваивание значения полю: 
            num = n;
        }
        // Описание метода из интерфейса: 
        public int getNum() {
            // Значение поля: 
            return num;
        }
        // Описание свойства из интерфейса: 
        public int number {
            // Аксессор для считывания значения: 
            get {
                // Вызывается метод из интерфейса: 
                return getNum();
            }
            // Аксессор для присваивания значения: 
            set {
                // Вызывается метод из интерфейса: 
                setNum(value);
            }
        }
        // Описание индексатора из интерфейса: 
        public int this[int k] {
            // Аксессор для считывания значения: 
            get {
                // Локальная переменная: 
                int r = number;
                // "Отбрасывание" цифр в десятичном представлении числа: 
                for(int i = 0; i < k; i++) { 
                    r /= 10;
                }
                // Результат: 
                return r % 10;
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Целочисленная переменная: 
            int m = 9;
            // Создание объекта:
            MyClass obj = new MyClass(12345);
            // Индексирование объекта: 
            for(int i = 0; i <= m; i++) {
                Console.Write("|" + obj[m-i]);
            }
            Console.WriteLine("|");
            // Задержка:
            Console.ReadLine();
        }
    }
}
